Subject: Re: bug#19102: 24.4; outline-move-subtree-up/down error at last and second-last subtree

From: Eli Zaretskii <[email-masked]>
Date: Fri, 21 Nov 2014 12:42:56 +0200

> From: Stephen Berman <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Fri, 21 Nov 2014 11:32:20 +0100
> 
> > Does it make sense to fix outline-move-subtree-up/down so that they
> > also work when there's no empty line after the last subtree?  That's
> 
> It didn't occur to me before, but your question prompted me to check and
> I see outline-mode derives from text-mode, which sets
> require-final-newline to mode-require-final-newline, so I guess the
> assumption is indeed that files in outline-mode should end in a newline.

Does doing that solve the problem without the need to delete the added
line?

> > one thing that looks inelegant in your patch, and might also cause
> > some (minor) trouble: what if the user types C-g before this function
> > finishes?
> 
> We could avoid the trouble by wrapping the newline call in
> unwind-protect, couldn't we?

Yes, but it's better to avoid that in the first place.

> But can C-g really take effect here?
> There is no place in the function where execution halts to wait for user
> feedback.

C-g sets a flag that is checked by evaluation.

> I guess those are idle speculations, it does seem that just keeping a
> final newline added by the function is the simplest (and perhaps best)
> fix, so I guess we should commit some version of that fix and see if
> anyone complains.

Go for it, and thanks.